diff --exclude=CVS -Nru certi/libCERTI/GAV.cc certi.new/libCERTI/GAV.cc
--- certi/libCERTI/GAV.cc	2007-07-06 11:25:17.000000000 +0200
+++ certi.new/libCERTI/GAV.cc	2008-12-05 12:09:17.000000000 +0100
@@ -15,35 +15,571 @@
 // You should have received a copy of the GNU Lesser General Public
 // License along with this program ; if not, write to the Free Software
 // Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+//
+// $Id: Dimension.cc,v 3.8 2008/06/12 07:39:49 erk Exp $
 // ----------------------------------------------------------------------------
-// $id
-
-
 
 #include "GAV.hh"
 #include "PrettyDebug.hh"
+#include <string.h>
 
 #include <algorithm>
 #include <assert.h>
 
+using std::list ;
+
+using namespace certi ;
+
+// ----------------------------------------------------------------------------
+// AttributeHandleValuePair
+// ----------------------------------------------------------------------------
+
 namespace certi {
 
 static pdCDebug D("GAV", "(gav) - ");
 
 // ----------------------------------------------------------------------------
-// CAttributeHandleValuePair deleted
+AttributeHandleValuePair::AttributeHandleValuePair(Handle handle,
+                                                   const char *value,
+                                                   ULong value_length)
+{
+    _handle = handle ;
+    _valueLength = value_length ;
+
+    _value = new char[value_length];
+    memcpy(_value, value, value_length);
+}
+
+// ----------------------------------------------------------------------------
+AttributeHandleValuePair::~AttributeHandleValuePair()
+{
+    delete[] _value ;
+}
+
+// ----------------------------------------------------------------------------
+// AttributeHandleValuePairSet
+// ----------------------------------------------------------------------------
+AttributeHandleValuePairSet::AttributeHandleValuePairSet(ULong)
+{
+    _order = RECEIVE ;
+    _transport = RELIABLE ;
+}
+
 // ----------------------------------------------------------------------------
+AttributeHandleValuePairSet::~AttributeHandleValuePairSet()
+{
+    empty();
+}
 
 // ----------------------------------------------------------------------------
-// CParameterHandleValuePair deleted
+ULong
+AttributeHandleValuePairSet::size() const
+{
+    return list<AttributeHandleValuePair *>::size();
+}
+
 // ----------------------------------------------------------------------------
+Handle
+AttributeHandleValuePairSet::getHandle(ULong i) const
+    throw (ArrayIndexOutOfBounds)
+{
+    list<AttributeHandleValuePair *>::const_iterator j = begin();
+    for (ULong k = 0 ; j != end(); j++, k++) {
+        if (i == k)
+            return (*j)->_handle ;
+    }
+
+    throw ArrayIndexOutOfBounds("");
+}
 
 // ----------------------------------------------------------------------------
-// CAttributeHandleValuePairSet deleted
+ULong
+AttributeHandleValuePairSet::getValueLength(ULong i) const
+    throw (ArrayIndexOutOfBounds)
+{
+    list<AttributeHandleValuePair *>::const_iterator j = begin();
+    for (ULong k = 0 ; j != end(); j++, k++) {
+        if (i == k)
+            return (*j)->_valueLength ;
+    }
+
+    throw ArrayIndexOutOfBounds("");
+}
+
+// ----------------------------------------------------------------------------
+void
+AttributeHandleValuePairSet::getValue(ULong i,
+                                         char *buff,
+                                         ULong& value_length) const
+    throw (ArrayIndexOutOfBounds)
+{
+    list<AttributeHandleValuePair *>::const_iterator j = begin();
+    for (ULong k = 0 ; j != end(); j++, k++) {
+        if (i == k) {
+            value_length = (*j)->_valueLength ;
+            memcpy(buff, (*j)->_value, (*j)->_valueLength);
+            return ;
+        }
+    }
+
+    throw ArrayIndexOutOfBounds("");
+}
+
+// ----------------------------------------------------------------------------
+char *
+AttributeHandleValuePairSet::getValuePointer(ULong i,
+                                                ULong& value_length) const
+    throw (ArrayIndexOutOfBounds)
+{
+    list<AttributeHandleValuePair *>::const_iterator j = begin();
+    for (ULong k = 0 ; j != end(); j++, k++) {
+        if (i == k) {
+            value_length = (*j)->_valueLength ;
+            return (*j)->_value ;
+        }
+    }
+
+    throw ArrayIndexOutOfBounds("");
+}
+
+// ----------------------------------------------------------------------------
+TransportType
+AttributeHandleValuePairSet::getTransportType(ULong) const
+    throw (InvalidHandleValuePairSetContext)
+{
+    return _transport ;
+}
+
+// ----------------------------------------------------------------------------
+OrderType
+AttributeHandleValuePairSet::getOrderType(ULong) const
+    throw (ArrayIndexOutOfBounds, InvalidHandleValuePairSetContext)
+{
+    return _order ;
+}
+
+// ----------------------------------------------------------------------------
+RTI::Region *
+AttributeHandleValuePairSet::getRegion(ULong) const
+    throw (ArrayIndexOutOfBounds, InvalidHandleValuePairSetContext)
+{
+    throw RTIinternalError("Unimplemented service");
+}
+
+// ----------------------------------------------------------------------------
+void
+AttributeHandleValuePairSet::add(Handle h,
+                                    const char *buff,
+                                    ULong value_length)
+    throw (ValueLengthExceeded, ValueCountExceeded)
+{
+    AttributeHandleValuePair *ahvp ;
+    ahvp = new AttributeHandleValuePair(h, buff, value_length);
+
+    push_front(ahvp);
+}
+
+// ----------------------------------------------------------------------------
+void
+AttributeHandleValuePairSet::remove(Handle h)
+    throw (ArrayIndexOutOfBounds)
+{
+    list<AttributeHandleValuePair *>::iterator j ;
+    for (j = begin(); j != end(); j++) {
+        if ((*j)->_handle == h) {
+            delete (*j);
+            erase(j);
+            return ;
+        }
+    }
+
+    throw ArrayIndexOutOfBounds("");
+}
+
+// ----------------------------------------------------------------------------
+void
+AttributeHandleValuePairSet::moveFrom(const AttributeHandleValuePairSet&,
+                                         ULong&)
+    throw (ValueCountExceeded, ArrayIndexOutOfBounds)
+{
+    throw RTIinternalError("Unimplemented service");
+}
+
+// ----------------------------------------------------------------------------
+void
+AttributeHandleValuePairSet::empty()
+{
+    while (!list<AttributeHandleValuePair *>::empty()) {
+        delete front();
+        pop_front();
+    }
+}
+
+// ----------------------------------------------------------------------------
+ULong
+AttributeHandleValuePairSet::start() const
+{
+    //not implemented
+    return 0 ;
+}
+
+// ----------------------------------------------------------------------------
+ULong
+AttributeHandleValuePairSet::valid(ULong) const
+{
+    //not implemented
+    return 0 ;
+}
+
+// ----------------------------------------------------------------------------
+ULong
+AttributeHandleValuePairSet::next(ULong) const
+{
+    //not implemented
+    return 0 ;
+}
+
+// ----------------------------------------------------------------------------
+// AttributeHandleSet
+// ----------------------------------------------------------------------------
+AttributeHandleSet::AttributeHandleSet(ULong size)
+{
+}
+
+AttributeHandleSet::~AttributeHandleSet()
+{
+    empty();
+}
+
+// ----------------------------------------------------------------------------
+inline ULong
+AttributeHandleSet::size() const
+{
+    return list<AttributeHandle>::size();
+}
+
+// ----------------------------------------------------------------------------
+AttributeHandle
+AttributeHandleSet::getHandle(ULong i) const
+    throw (ArrayIndexOutOfBounds)
+{
+    list<AttributeHandle>::const_iterator h ;
+    ULong j ;
+    for (j = 0, h = begin(); h != end(); h++, j++) {
+        if (i == j)
+            return (*h);
+    }
+
+    throw ArrayIndexOutOfBounds("");
+}
+
+// ----------------------------------------------------------------------------
+void
+AttributeHandleSet::add(AttributeHandle h)
+    throw (ArrayIndexOutOfBounds, AttributeNotDefined)
+{
+    push_front(h);
+}
+
+// ----------------------------------------------------------------------------
+void
+AttributeHandleSet::remove(AttributeHandle h)
+    throw (AttributeNotDefined)// not guaranteed safe while iterating
+{
+    if (isMember(h) == RTI::RTI_TRUE)
+        list<AttributeHandle>::remove(h);
+    else
+        throw AttributeNotDefined("");
+}
+
+// ----------------------------------------------------------------------------
+void
+AttributeHandleSet::empty()
+{
+    list<AttributeHandle>::clear();
+}
+
+// ----------------------------------------------------------------------------
+RTI::Boolean
+AttributeHandleSet::isEmpty() const
+{
+    return RTI::Boolean(list<AttributeHandle>::empty());
+}
+
 // ----------------------------------------------------------------------------
+RTI::Boolean
+AttributeHandleSet::isMember(AttributeHandle h) const
+{
+    return RTI::Boolean(find(begin(), end(), h) != end());
+}
 
 // ----------------------------------------------------------------------------
-// CParameterHandleValuePairSet deleted
+// FederateHandleSet
 // ----------------------------------------------------------------------------
+FederateHandleSet::~FederateHandleSet()
+{
+    empty();
+}
+
+// ----------------------------------------------------------------------------
+inline ULong
+FederateHandleSet::size() const
+{
+    return list<FederateHandle>::size();
+}
+
+// ----------------------------------------------------------------------------
+FederateHandle
+FederateHandleSet::getHandle(ULong i) const
+    throw (ArrayIndexOutOfBounds)
+{
+    list<FederateHandle>::const_iterator h ;
+    ULong j ;
+    for (j = 0, h = begin(); h != end(); h++, j++) {
+        if (i == j)
+            return (*h);
+    }
+
+    throw ArrayIndexOutOfBounds("");
+}
+
+// ----------------------------------------------------------------------------
+void
+FederateHandleSet::add(FederateHandle h)
+    throw (ValueCountExceeded)
+{
+    push_front(h);
+}
+
+// ----------------------------------------------------------------------------
+void
+FederateHandleSet::remove(FederateHandle h)
+    throw (ArrayIndexOutOfBounds)
+{
+    if (isMember(h) == RTI::RTI_TRUE)
+        list<FederateHandle>::remove(h);
+    else
+        throw AttributeNotDefined("");
+}
+
+// ----------------------------------------------------------------------------
+void
+FederateHandleSet::empty()
+{
+    list<FederateHandle>::clear();
+}
+
+// ----------------------------------------------------------------------------
+RTI::Boolean
+FederateHandleSet::isMember(FederateHandle h) const
+{
+    return RTI::Boolean(find(begin(), end(), h) != end());
+}
+
+// ----------------------------------------------------------------------------
+// ParameterHandleValuePair
+// ----------------------------------------------------------------------------
+
+ParameterHandleValuePair::ParameterHandleValuePair(Handle handle,
+                                                   const char *value,
+                                                   ULong value_length)
+{
+    _handle = handle ;
+    _valueLength = value_length ;
+
+    _value = (char *) malloc(value_length);
+    memcpy(_value, value, value_length);
+}
+
+// ----------------------------------------------------------------------------
+ParameterHandleValuePair::~ParameterHandleValuePair()
+{
+    free(_value);
+}
+
+// ----------------------------------------------------------------------------
+// ParameterHandleValuePairSet
+// ----------------------------------------------------------------------------
+ParameterHandleValuePairSet::ParameterHandleValuePairSet(ULong)
+{
+    _order = RECEIVE ;
+    _transport = RELIABLE ;
+}
+
+ParameterHandleValuePairSet::~ParameterHandleValuePairSet()
+{
+    empty();
+}
+
+// ----------------------------------------------------------------------------
+ULong
+ParameterHandleValuePairSet::size() const
+{
+    return list<ParameterHandleValuePair *>::size();
+}
+
+// ----------------------------------------------------------------------------
+Handle
+ParameterHandleValuePairSet::getHandle(ULong i) const
+    throw (ArrayIndexOutOfBounds)
+{
+    list<ParameterHandleValuePair *>::const_iterator j = begin();
+    for (ULong k = 0 ; j != end(); j++, k++) {
+        if (i == k)
+            return (*j)->_handle ;
+    }
+
+    throw ArrayIndexOutOfBounds("");
+}
+
+// ----------------------------------------------------------------------------
+ULong
+ParameterHandleValuePairSet::getValueLength(ULong i) const
+    throw (ArrayIndexOutOfBounds)
+{
+    list<ParameterHandleValuePair *>::const_iterator j = begin();
+    for (ULong k = 0 ; j != end(); j++, k++) {
+        if (i == k)
+            return (*j)->_valueLength ;
+    }
+
+    throw ArrayIndexOutOfBounds("");
+}
+
+// ----------------------------------------------------------------------------
+void
+ParameterHandleValuePairSet::getValue(ULong i,
+                                         char *buff,
+                                         ULong& value_length) const
+    throw (ArrayIndexOutOfBounds)
+{
+    list<ParameterHandleValuePair *>::const_iterator j = begin();
+    for (ULong k = 0 ; j != end(); j++, k++) {
+        if (i == k) {
+            value_length = (*j)->_valueLength ;
+            memcpy(buff, (*j)->_value, (*j)->_valueLength);
+            return ;
+        }
+    }
+
+    throw ArrayIndexOutOfBounds("");
+}
+
+// ----------------------------------------------------------------------------
+char *
+ParameterHandleValuePairSet::getValuePointer(ULong i,
+                                                ULong& value_length) const
+    throw (ArrayIndexOutOfBounds)
+{
+    list<ParameterHandleValuePair *>::const_iterator j = begin();
+    for (ULong k = 0 ; j != end(); j++, k++) {
+        if (i == k) {
+            value_length = (*j)->_valueLength ;
+            return (*j)->_value ;
+        }
+    }
+
+    throw ArrayIndexOutOfBounds("");
+}
+
+// ----------------------------------------------------------------------------
+inline TransportType
+ParameterHandleValuePairSet::getTransportType() const
+    throw (InvalidHandleValuePairSetContext)
+{
+    return _transport ;
+}
+
+// ----------------------------------------------------------------------------
+inline OrderType
+ParameterHandleValuePairSet::getOrderType() const
+    throw (InvalidHandleValuePairSetContext)
+{
+    return _order ;
+}
+
+// ----------------------------------------------------------------------------
+RTI::Region *
+ParameterHandleValuePairSet::getRegion() const
+    throw (InvalidHandleValuePairSetContext)
+{
+    throw RTIinternalError("Unimplemented service");
+}
+
+// ----------------------------------------------------------------------------
+void
+ParameterHandleValuePairSet::add(Handle h,
+                                    const char *buff,
+                                    ULong value_length)
+    throw (ValueLengthExceeded, ValueCountExceeded)
+{
+    ParameterHandleValuePair *phvp ;
+    phvp = new ParameterHandleValuePair(h, buff, value_length);
+
+    push_front(phvp);
+}
+
+// ----------------------------------------------------------------------------
+void
+ParameterHandleValuePairSet::remove(Handle h)
+    throw (ArrayIndexOutOfBounds)
+{
+    list<ParameterHandleValuePair *>::iterator j ;
+    for (j = begin(); j != end(); j++) {
+        if ((*j)->_handle == h) {
+            delete (*j);
+            erase(j);
+            return ;
+        }
+    }
+
+    throw ArrayIndexOutOfBounds("");
+}
+
+// ----------------------------------------------------------------------------
+void
+ParameterHandleValuePairSet::moveFrom(const ParameterHandleValuePairSet&,
+                                         ULong&)
+    throw (ValueCountExceeded, ArrayIndexOutOfBounds)
+{
+    throw RTIinternalError("Unimplemented service");
+}
+
+// ----------------------------------------------------------------------------
+void
+ParameterHandleValuePairSet::empty()
+{
+    while (!list<ParameterHandleValuePair *>::empty()) {
+        delete front();
+        pop_front();
+    }
+}
+
+// ----------------------------------------------------------------------------
+ULong
+ParameterHandleValuePairSet::start() const
+{
+    //not implemented
+    return 0 ;
+}
+
+// ----------------------------------------------------------------------------
+ULong
+ParameterHandleValuePairSet::valid(ULong) const
+{
+    //not implemented
+    return 0 ;
+}
+
+// ----------------------------------------------------------------------------
+ULong
+ParameterHandleValuePairSet::next(ULong) const
+{
+    //not implemented
+    return 0 ;
+}
 
 } // namespace certi
+
+// $Id: GAV.cc,v 3.18 2008/11/25 16:32:14 gotthardp Exp $
+
diff --exclude=CVS -Nru certi/libCERTI/GAV.hh certi.new/libCERTI/GAV.hh
--- certi/libCERTI/GAV.hh	2008-06-25 10:27:47.000000000 +0200
+++ certi.new/libCERTI/GAV.hh	2008-11-27 17:15:02.000000000 +0100
@@ -21,16 +21,18 @@
 #define CERTI_GAV_HH
 
 #include "certi.hh"
+#include "Exception.hh"
 
 #include <list>
 
 namespace certi {
 
-class AttributeHandleSetImp
-    : public std::list<AttributeHandle>, public AttributeHandleSet
+class AttributeHandleSet
+    : public std::list<AttributeHandle>
 {
 public:
-    virtual ~AttributeHandleSetImp();
+    AttributeHandleSet(ULong size);
+    virtual ~AttributeHandleSet();
 
     virtual ULong size() const ;
 
@@ -49,10 +51,11 @@
     virtual RTI::Boolean isMember(AttributeHandle h) const ;
 };
 
-class FederateHandleSetImp : public std::list<FederateHandle>, RTI::FederateHandleSet
+class FederateHandleSet : public std::list<FederateHandle>
 {
 public:
-    virtual ~FederateHandleSetImp();
+    FederateHandleSet(ULong size);
+    virtual ~FederateHandleSet();
 
     virtual ULong size() const ;
 
@@ -63,7 +66,7 @@
         throw (ValueCountExceeded);
 
     virtual void remove(FederateHandle h)
-        throw (RTI::ArrayIndexOutOfBounds);
+        throw (ArrayIndexOutOfBounds);
 
     virtual void empty();
 
@@ -86,8 +89,8 @@
     ~AttributeHandleValuePair();
 };
 
-class AttributeHandleValuePairSetImp
-    : public std::list<AttributeHandleValuePair *>, RTI::AttributeHandleValuePairSet
+class AttributeHandleValuePairSet
+    : public std::list<AttributeHandleValuePair *>
 {
     // ATTRIBUTES
 public:
@@ -96,7 +99,8 @@
 
     // METHODS
 public:
-    virtual ~AttributeHandleValuePairSetImp();
+    AttributeHandleValuePairSet(ULong size);
+    virtual ~AttributeHandleValuePairSet();
 
     virtual ULong size() const ;
     virtual Handle getHandle(ULong i) const throw (ArrayIndexOutOfBounds);
@@ -109,7 +113,7 @@
         throw (ArrayIndexOutOfBounds);
 
     virtual TransportType getTransportType(ULong i) const
-        throw (RTI::InvalidHandleValuePairSetContext);
+        throw (InvalidHandleValuePairSetContext);
 
     virtual OrderType getOrderType(ULong i) const
         throw (ArrayIndexOutOfBounds, InvalidHandleValuePairSetContext);
@@ -141,16 +145,16 @@
     ~ParameterHandleValuePair();
 };
 
-class ParameterHandleValuePairSetImp
-    : public std::list<ParameterHandleValuePair *>, public RTI::ParameterHandleValuePairSet
+class ParameterHandleValuePairSet
+    : public std::list<ParameterHandleValuePair *>
 {
 public:
     OrderType _order ;
     TransportType _transport ;
 
 public:
-    ParameterHandleValuePairSetImp(ULong size);
-    virtual ~ParameterHandleValuePairSetImp();
+    ParameterHandleValuePairSet(ULong size);
+    virtual ~ParameterHandleValuePairSet();
 
     virtual ULong size() const ;
 
diff --exclude=CVS -Nru certi/libCERTI/GSSAPIHandler.cc certi.new/libCERTI/GSSAPIHandler.cc
--- certi/libCERTI/GSSAPIHandler.cc	2007-07-06 11:25:17.000000000 +0200
+++ certi.new/libCERTI/GSSAPIHandler.cc	2008-11-26 10:27:03.000000000 +0100
@@ -24,10 +24,7 @@
 
 #ifdef WITH_GSSAPI
 
-
-
 #include "GSSAPIHandler.hh"
-#include "RTItypes.hh"
 #include "PrettyDebug.hh"
 #include "SocketTCP.hh"
 
diff --exclude=CVS -Nru certi/libCERTI/LBTS.cc certi.new/libCERTI/LBTS.cc
--- certi/libCERTI/LBTS.cc	2008-06-23 15:25:05.000000000 +0200
+++ certi.new/libCERTI/LBTS.cc	2008-11-26 14:33:03.000000000 +0100
@@ -25,6 +25,7 @@
 
 
 #include "LBTS.hh"
+#include "Exception.hh"
 #include "PrettyDebug.hh"
 
 #ifndef _WIN32
diff --exclude=CVS -Nru certi/libCERTI/MessageBuffer.cc certi.new/libCERTI/MessageBuffer.cc
--- certi/libCERTI/MessageBuffer.cc	2008-09-18 16:41:28.000000000 +0200
+++ certi.new/libCERTI/MessageBuffer.cc	2008-11-26 14:33:28.000000000 +0100
@@ -20,6 +20,7 @@
 // ----------------------------------------------------------------------------
 
 #include "MessageBuffer.hh"
+#include "Exception.hh"
 #include "PrettyDebug.hh"
 #include <cassert>
 #include <sstream>
diff --exclude=CVS -Nru certi/libCERTI/Message.cc certi.new/libCERTI/Message.cc
--- certi/libCERTI/Message.cc	2008-10-28 13:07:26.000000000 +0100
+++ certi.new/libCERTI/Message.cc	2008-12-05 18:34:52.000000000 +0100
@@ -23,7 +23,6 @@
 #include "Message.hh"
 #include "certi.hh"
 #include "PrettyDebug.hh"
-#include "GAV.hh"
 
 #include <stdlib.h>
 #include <cstdio>
@@ -272,13 +271,9 @@
 */
 void
 Message::setException(TypeException the_exception,
-                      const char *the_reason)
+                      const std::string& the_reason)
 {
     exception = the_exception ;
-
-    if (strlen(the_reason) > MAX_EXCEPTION_REASON_LENGTH)
-        throw ValueLengthExceeded("Exception reason too long to fit in"
-                                  " Message.");
     exceptionReason = the_reason;
 }
 
@@ -290,29 +285,22 @@
 }
 
 // ----------------------------------------------------------------------------
-AttributeHandleSet*
+const std::vector<AttributeHandle>&
 Message::getAHS() const
 {
-    AttributeHandleSet *attributeSet ;
-    attributeSet = RTI::AttributeHandleSetFactory::create(handleArraySize);
-
-    for (int i = 0 ; i < handleArraySize ; i++) {
-        attributeSet->add(handleArray[i]);
-    }
-
-    return attributeSet ;
+    return handleArray;
 }
 
 // ----------------------------------------------------------------------------
 void
-Message::setAHS(const AttributeHandleSet &the_attributes)
+Message::setAHS(const std::vector<AttributeHandle> &the_attributes)
 {
     G.Out(pdGendoc,"enter Message::setAHS");
     handleArraySize = the_attributes.size();
     handleArray.resize(handleArraySize);
 
     for (unsigned int i = 0 ; i < the_attributes.size(); ++i) {
-        handleArray[i] = the_attributes.getHandle(i);
+        handleArray[i] = the_attributes[i];
     }
     G.Out(pdGendoc,"exit  Message::setAHS");
 }
@@ -332,16 +320,18 @@
 }
 
 // ----------------------------------------------------------------------------
-RTI::AttributeHandleValuePairSet *
+std::vector<std::pair<AttributeHandle, AttributeValue_t> >
 Message::getAHVPS() const
 {
-    RTI::AttributeHandleValuePairSet *ahvps ;
-    ahvps = RTI::AttributeSetFactory::create(handleArraySize);
+    std::vector<std::pair<AttributeHandle, AttributeValue_t> > result;
+    result.resize(handleArraySize);
 
-    for (int i = 0 ; i < handleArraySize ; i++)
-        ahvps->add(handleArray[i], valueArray[i].data(), valueArray[i].length());
+    for (int i = 0 ; i < handleArraySize ; i++) {
+        result[i].first = handleArray[i];
+        result[i].second.assign(valueArray[i].data(), valueArray[i].length());
+    }
 
-    return ahvps ;
+    return result;
 }
 
 // ----------------------------------------------------------------------------
@@ -349,7 +339,7 @@
     @param the_attributes attribute set
 */
 void
-Message::setAHVPS(const RTI::AttributeHandleValuePairSet &the_attributes)
+Message::setAHVPS(const std::vector<std::pair<AttributeHandle, AttributeValue_t> > &the_attributes)
 {
     G.Out(pdGendoc,"enter Message::setAHVPS");
 
@@ -361,35 +351,30 @@
     valueArray.resize(size) ;
 
     for (unsigned long i = 0 ; i < size ; i++) {
-
-        // handle stored into handleArray[i]
-        handleArray[i] = the_attributes.getHandle(size-1-i);
-
-        // value stored into valueArray[i]
-        ULong length;
-        char *valueptr = the_attributes.getValuePointer(size-1-i, length);
-        valueArray[i].assign(valueptr, length);
-        // no free(valueptr), getValuePointer does not allocate memory
+        handleArray[i] = the_attributes[size-1-i].first;
+        valueArray[i] = the_attributes[size-1-i].second;
     }
     G.Out(pdGendoc,"exit  Message::setAHVPS");
 }
 
 // ----------------------------------------------------------------------------
-RTI::ParameterHandleValuePairSet *
+std::vector<std::pair<ParameterHandle, ParameterValue_t> >
 Message::getPHVPS() const
 {
-    ParameterHandleValuePairSetImp *phvps ;
-    phvps = new ParameterHandleValuePairSetImp(handleArraySize);
+    std::vector<std::pair<ParameterHandle, ParameterValue_t> > result;
+    result.resize(handleArraySize);
 
-    for (int i = 0 ; i < handleArraySize ; i++)
-        phvps->add(handleArray[i], valueArray[i].data(), valueArray[i].length());
+    for (int i = 0 ; i < handleArraySize ; i++) {
+        result[i].first = handleArray[i];
+        result[i].second.assign(valueArray[i].data(), valueArray[i].length());
+    }
 
-    return phvps ;
+    return result;
 }
 
 // ----------------------------------------------------------------------------
 void
-Message::setPHVPS(const RTI::ParameterHandleValuePairSet &the_parameters)
+Message::setPHVPS(const std::vector<std::pair<ParameterHandle, ParameterValue_t> > &the_parameters)
 {
     G.Out(pdGendoc,"enter Message::setPHVPS");
 
@@ -401,15 +386,8 @@
     valueArray.resize(size) ;
 
     for (unsigned long i = 0 ; i < size ; i++) {
-
-        // handle stored into handleArray[i]
-        handleArray[i] = the_parameters.getHandle(size-1-i);
-
-        // value stored into valueArray[i]
-        ULong length;
-        char *valueptr = the_parameters.getValuePointer(size-1-i, length);
-        valueArray[i].assign(valueptr, length);
-        // no free(valueptr), getValuePointer does not allocate memory
+        handleArray[i] = the_parameters[size-1-i].first;
+        valueArray[i] = the_parameters[size-1-i].second;
     }
     G.Out(pdGendoc,"exit  Message::setPHVPS");
 }
@@ -441,9 +419,7 @@
     valueArray.resize(the_size) ;
 
     for (int i = 0 ; i < the_size ; i++) {
-        // attributes into handleArray
         handleArray[i] = the_attributes[i] ;
-        // values into valueArray
         valueArray[i] = the_values[i] ;
     }
     G.Out(pdGendoc,"exit  Message::setAttributes");
@@ -464,9 +440,7 @@
     valueArray.resize(the_size) ;
 
     for (int i = 0 ; i < the_size ; i++) {
-        // parameters into handleArray
         handleArray[i] = the_parameters[i] ;
-        // values into valueArray
         valueArray[i] = the_values[i] ;
     }
 }
@@ -599,7 +573,7 @@
         printf("NO_EXCEPTION ");
     else
         printf(" exception=%d: ",exception);
-    printf(" reason=%s: ",((exceptionReason.c_str()==NULL)?"empty":exceptionReason.c_str()));
+    printf(" reason=%s: ",(exceptionReason.empty()?"empty":exceptionReason.c_str()));
     printf(" objectClass=%ld: ", objectClass);
     printf(" interactionClass=%ld:\n", interactionClass);
     printf(" attribute=%ld:\n", attribute);
diff --exclude=CVS -Nru certi/libCERTI/Message.hh certi.new/libCERTI/Message.hh
--- certi/libCERTI/Message.hh	2008-11-06 15:28:58.000000000 +0100
+++ certi.new/libCERTI/Message.hh	2008-12-05 17:36:34.000000000 +0100
@@ -25,6 +25,7 @@
 #include "Exception.hh"
 #include "SocketUN.hh"
 #include "BasicMessage.hh"
+#include "GAV.hh"
 #include "fedtime.hh"
 
 #include <vector>
@@ -333,7 +334,7 @@
 
     void setFederationTime(FederationTime);
     FederationTime getFederationTime() const { return fed_time.getTime(); };
-    
+
     void setBoolean(bool);
     bool getBoolean() const { return boolean ; };
 
@@ -350,7 +351,6 @@
 
     void setEventRetraction(EventRetractionHandle);
     EventRetractionHandle getEventRetraction() const
-
     { return eventRetraction ; };
 
     void setParameter(ParameterHandle);
@@ -359,21 +359,21 @@
     void setFederate(FederateHandle);
     FederateHandle getFederate() const { return federate ; };
 
-    AttributeHandleSet* getAHS() const ;
-    void setAHS(const AttributeHandleSet &);
+    const std::vector<AttributeHandle>& getAHS() const ;
+    void setAHS(const std::vector<AttributeHandle> &);
     void setAHS(const AttributeHandle *, int);
 
-    RTI::AttributeHandleValuePairSet* getAHVPS() const ;
-    void setAHVPS(const RTI::AttributeHandleValuePairSet &);
+    std::vector<std::pair<AttributeHandle, AttributeValue_t> > getAHVPS() const ;
+    void setAHVPS(const std::vector<std::pair<AttributeHandle, AttributeValue_t> > &);
 
-    RTI::ParameterHandleValuePairSet* getPHVPS() const ;
-    void setPHVPS(const RTI::ParameterHandleValuePairSet &);
+    std::vector<std::pair<ParameterHandle, ParameterValue_t> > getPHVPS() const ;
+    void setPHVPS(const std::vector<std::pair<ParameterHandle, ParameterValue_t> > &);
 
     void setAttributes(std::vector <AttributeHandle> &, ushort);
     void setAttributes(std::vector <AttributeHandle> &, std::vector <AttributeValue_t> &, ushort);
     void setParameters(std::vector <ParameterHandle> &, std::vector <ParameterValue_t> &, ushort);
 
-    void setException(TypeException, const char *the_reason = "\0");
+    void setException(TypeException, const std::string& the_reason = "");
     TypeException getExceptionType() const { return exception ; };
     const char *getExceptionReason() const { return exceptionReason.c_str() ; };
 
@@ -387,7 +387,6 @@
 
 protected:
     TypeException exception ;
-    //char exceptionReason[MAX_EXCEPTION_REASON_LENGTH + 1] ;
     std::string exceptionReason;
 
     RTIfedTime fed_time;
diff --exclude=CVS -Nru certi/libCERTI/ObjectAttribute.hh certi.new/libCERTI/ObjectAttribute.hh
--- certi/libCERTI/ObjectAttribute.hh	2007-06-22 10:51:38.000000000 +0200
+++ certi.new/libCERTI/ObjectAttribute.hh	2008-11-26 14:29:24.000000000 +0100
@@ -26,6 +26,7 @@
 #define CERTI_OBJECT_ATTRIBUTE_HH
 
 #include "certi.hh"
+#include "Exception.hh"
 
 #include <list>
 
diff --exclude=CVS -Nru certi/libCERTI/ObjectClass.cc certi.new/libCERTI/ObjectClass.cc
--- certi/libCERTI/ObjectClass.cc	2008-11-08 12:36:05.000000000 +0100
+++ certi.new/libCERTI/ObjectClass.cc	2008-11-26 14:29:51.000000000 +0100
@@ -1603,7 +1603,7 @@
     if (server != NULL) {
         CDiffusion *diffusionAcquisition = new CDiffusion();
 
-        theAttribute = RTI::AttributeHandleSetFactory::create(the_size);
+        theAttribute = new AttributeHandleSet(the_size);
 
         ObjectClassAttribute * oca ;
         for (int i = 0 ; i < the_size ; i++) {
diff --exclude=CVS -Nru certi/libCERTI/ObjectClass.hh certi.new/libCERTI/ObjectClass.hh
--- certi/libCERTI/ObjectClass.hh	2008-11-08 12:08:03.000000000 +0100
+++ certi.new/libCERTI/ObjectClass.hh	2008-11-26 14:28:10.000000000 +0100
@@ -39,6 +39,7 @@
 #include "certi.hh"
 #include "SecurityServer.hh"
 #include "Named.hh"
+#include "GAV.hh"
 
 // Standard
 #include <list>
diff --exclude=CVS -Nru certi/libCERTI/Object.hh certi.new/libCERTI/Object.hh
--- certi/libCERTI/Object.hh	2008-09-18 19:13:32.000000000 +0200
+++ certi.new/libCERTI/Object.hh	2008-11-26 11:49:22.000000000 +0100
@@ -34,6 +34,7 @@
 #include "certi.hh"
 #include "Named.hh"
 #include "Handled.hh"
+#include "Exception.hh"
 
 #include <deque>
 #include <list>
